package ru.dbotthepony.kstarbound.world.entities

import ru.dbotthepony.kstarbound.GlobalDefaults
import ru.dbotthepony.kstarbound.Starbound
import ru.dbotthepony.kstarbound.world.World
import ru.dbotthepony.kstarbound.world.physics.Poly

class PlayerEntity(world: World<*, *>) : Entity(world) {
	init {
		movementParameters = GlobalDefaults.playerMovementParameters

		GlobalDefaults.playerMovementParameters.standingPoly.ifPresent {
			//hitboxes.add(it)
			hitboxes.add(Starbound.gson.fromJson("""[ [0.5625, 1.9375], [1.0625, 1.4375], [1.0625, -2.5625], [0.5625, -3.0625], [-0.5625, -3.0625], [-1.0625, -2.5625], [-1.0625, 1.4375], [-0.5625, 1.9375] ]""", Poly::class.java))
		}.ifNotPresent {
			throw IllegalStateException("No player collision poly")
		}
	}
}
